!------>
!This program used to generate PIPs for molecule of A3B1 type
!up to 3rd order.
!------>

!********************************************************
        subroutine bemsav(x,p)
        implicit none
        double precision,intent(in) :: x(1:6)
        double precision,intent(out) :: p(0:22)
        double precision :: m(0:29)

        call evmono(x,m)
        call evpoly(m,p)

        return
        end subroutine bemsav
!********************************************************

!********************************************************
        subroutine evmono(x,m)
        implicit none
        double precision,intent(in) :: x(1:6)
        double precision,intent(out) :: m(0:29)

        m(0) = 1.0D0
        m(1) = x(6)
        m(2) = x(5)
        m(3) = x(3)
        m(4) = x(4)
        m(5) = x(2)
        m(6) = x(1)
        m(7) = m(1)*m(2)
        m(8) = m(1)*m(3)
        m(9) = m(2)*m(3)
        m(10) = m(3)*m(4)
        m(11) = m(2)*m(5)
        m(12) = m(1)*m(6)
        m(13) = m(4)*m(5)
        m(14) = m(4)*m(6)
        m(15) = m(5)*m(6)
        m(16) = m(1)*m(9)
        m(17) = m(1)*m(10)
        m(18) = m(2)*m(10)
        m(19) = m(1)*m(11)
        m(20) = m(3)*m(11)
        m(21) = m(2)*m(12)
        m(22) = m(3)*m(12)
        m(23) = m(2)*m(13)
        m(24) = m(3)*m(13)
        m(25) = m(1)*m(14)
        m(26) = m(3)*m(14)
        m(27) = m(1)*m(15)
        m(28) = m(2)*m(15)
        m(29) = m(4)*m(15)

        return
        end subroutine evmono
!********************************************************

!********************************************************
        subroutine evpoly(m,p)
        implicit none
        double precision,intent(in) :: m(0:29)
        double precision,intent(out) :: p(0:22)

        p(0) = m(0)                                          
        p(1) = m(1) + m(2) + m(3)
        p(2) = m(4) + m(5) + m(6)
        p(3) = m(7) + m(8) + m(9)
        p(4) = m(10) + m(11) + m(12)
        p(5) = p(1)*p(2) - p(4)
        p(6) = m(13) + m(14) + m(15)
        p(7) = p(1)*p(1) - p(3) - p(3)
        p(8) = p(2)*p(2) - p(6) - p(6)
        p(9) = m(16)
        p(10) = m(17) + m(18) + m(19) + m(20) + m(21) + m(22)
        p(11) = p(2)*p(3) - p(10)
        p(12) = m(23) + m(24) + m(25) + m(26) + m(27) + m(28)
        p(13) = m(29)
        p(14) = p(1)*p(6) - p(12)
        p(15) = p(1)*p(3) - p(9) - p(9) - p(9)
        p(16) = p(1)*p(4) - p(10)
        p(17) = p(2)*p(7) - p(16)
        p(18) = p(2)*p(4) - p(12)
        p(19) = p(1)*p(8) - p(18)
        p(20) = p(2)*p(6) - p(13) - p(13) - p(13)
        p(21) = p(1)*p(7) - p(15)
        p(22) = p(2)*p(8) - p(20)                            

        return
        end subroutine evpoly 
!********************************************************
